/* This file is Copyright 2000 Level Control Systems.  See the included LICENSE.txt file for details. */  

#include <stdio.h>

#include "queue/PortableQueue.h"

#define TEST(x) if (!(x)) printf("Test failed, line %i\n",__LINE__)

void PrintToStream(const PortableQueue<int> & q);
void PrintToStream(const PortableQueue<int> & q)
{
   printf("Queue state is:\n");
   for (int i=0; i<q.CountItems(); i++)
   {
/*
      int val;
      TEST(q.GetItemAt(i, val));    
      printf("%i -> %i\n",i,val);
*/
      printf("%i -> %i\n",i,q[i]);
   }
}

// This program exercises the PortableQueue class.
void main(void) 
{
   const int testSize = 10;
   PortableQueue<int> q;

   printf("ADDTAIL TEST\n");
   {
      for (int i=0; i<testSize; i++) 
      {
         TEST(q.AddTail(i));
         PrintToStream(q);
      }
   } 

   printf("REPLACEITEMAT TEST\n");
   {
      for (int i=0; i<testSize; i++) 
      {
         TEST(q.ReplaceItemAt(i, i+10));
         PrintToStream(q);
      }
   } 

   printf("INSERTITEMAT TEST\n");
   {
      for (int i=0; i<testSize; i++) 
      {
         TEST(q.InsertItemAt(i,i));
         PrintToStream(q);
      }
   }

   printf("REMOVEITEMAT TEST\n");
   {
      for (int i=0; i<testSize; i++) 
      {
         TEST(q.RemoveItemAt(i));
         PrintToStream(q);
      }
   }
}
